#!/usr/bin/perl

use strict;

my $file_seqseg = shift;
my $file_taxid2acc = shift;
die "Usage: perl $0 *.seqseg *.taxid2acc\n" if ($file_taxid2acc eq "");

my $href_acc={};
my $href_seq={};

open (IN, "$file_taxid2acc");
my @pairs = <IN>;
chomp(@pairs);

foreach my $pair (@pairs) {
	my ($t1, $t2, $t3) = split (/\t/, $pair);
	my (@accs) = split (/\s+/, $t3);
	foreach my $acc (@accs) {
		$href_acc->{$acc} = $t2;
	}
}
close (IN);

####################################################
open (IN, "$file_seqseg");
my @seqs = <IN>;
chomp(@seqs);

my ($t1, $t2) = "";
foreach my $seq (@seqs) {
	if ($seq =~ /^>/) {
		($t1, $t2) = split (/\t/, $seq);
		$t1 =~ s/\>//;
	} elsif ($seq =~ /\#/) {
		$seq =~ s/\#\#\#\#\#//g;
		$seq =~ s/\s+//g;
		$href_seq->{$t1} = $seq;
	} else {}
}
close (IN);

foreach my $key (keys %$href_acc) {
	print ">refbc_".$href_acc->{$key}."_".$key."_$href_seq->{$key}\n" if ($href_seq->{$key} ne "");
}
