#!/usr/bin/perl

use strict;
use Time::HiRes qw/gettimeofday/;
use Getopt::Long;

my $file_seq = "";

##Set up environment variables
#sample usage: 
#cd $work_dir
#cat ../../byclass | perl ../../scripts/pt14_makeblastdb.pl

my $file_seq = shift;
my $makeblastdb = shift || 0;
if ($file_seq eq "") { die "Usage:cat listofacc | $0 1line\n"; }

open (IN, $file_seq) || die "failed to open file $file_seq\n";

my $href_seqs = {};
my $href_taxid = {};
my $href_hits = {};

my @lines = <IN>;
close (IN);
($href_seqs, $href_taxid) = &loadseq (\@lines);

my @lines = <STDIN>;

foreach my $line (@lines) {

	my ($taxid, $accs) = split (/\t/, $line);
	$accs =~ s/^\s+//;
	$accs =~ s/\s+$//;

	if ($accs =~ /\w/) {
	my $file_out = "fas_".$taxid;
	open (OUT, ">$file_out");

	my @accs = split (/\s+/, $accs);
	foreach my $acc (@accs) {
		print OUT ">refbc_$href_taxid->{$acc}_$acc\n$href_seqs->{$acc}\n" if ($href_seqs->{$acc});
	}

	close(OUT);
	`formatdb -p F -i $file_out -o T` if ($makeblastdb ne 0);
	}
}

#################################################################
sub loadseq {
        my ($aref) = @_;
        my $href_seqs = {}; #key is acc, value is the sequence
        my $href_taxid = {}; #key is acc, value is the taxid

        foreach my $line (@$aref) {
                $line =~ s/\s+$//;
                my @tmps = split(/_/, $line);
		next if ($tmps[3] eq "");
                $href_seqs->{$tmps[2]} = $tmps[3];
                $href_taxid->{$tmps[2]} = $tmps[1];
        }

        return $href_seqs, $href_taxid;
}

