#!/usr/bin/perl

use strict;
use FindBin;

=head
this program will need two files: prefix.taxid2acc.txt and prefix.seqseg, the input can be the path to these two files and the otu such as class, order, family and genus. 
however, it will also need to have the file prefix.lineage, which if the database is not updated, it is better to have it provided. 
=cut

my $prefix = shift || "out";
my $otu = shift;
my $outdir = shift; 

die "Usage: $0 prefix otu outdir\notu can be family, class or genus\n" if ($otu eq "");

#my $schome = "/home/cliu/scprod";
my $schome = $FindBin::Bin;
#my $schome = "/home/cliu/tmp/forliangdong/scripts";
my $file_lineage = $prefix.".lineage";
my $file_taxid2acc_in = $prefix.".taxid2acc.txt";
my $file_taxid2acc = $prefix.".taxid2acctmp.txt";
my $file_seqseg = $prefix.".seqseg";
my $file_1line = $prefix.".1line";
my $file_listoftaxid = $prefix.".listoftaxid.".$otu;
my $file_listoftaxid2acc = $prefix.".listoftaxid2acc.".$otu;

if ($outdir eq "") {
    $outdir = ".";
} 
mkdir "$outdir", 0777 unless -d "$outdir";

#generate 1-n line
print STDERR "create 1-n taxies2acc\n";
`grep 1-n $file_taxid2acc_in > $file_taxid2acc`;
#`cp $file_taxid2acc $file_taxid2acc_all; grep 1-n $file_taxid2acc_in > $file_taxid2acc` unless (-e $file_taxid2acc_all);

#generate the lineage file
print STDERR "create lineage\n";
`cat $file_taxid2acc | cut -f2 | perl $schome/g1_findLineage.pl -infile stdin > $file_lineage` unless (-e $file_lineage);

#geneate the 1line file
print STDERR "create 1line\n";
`perl $schome/g1_create_seq2bmapped.pl $file_seqseg $file_taxid2acc > $file_1line` unless (-e $file_1line);

#get list of taxid
print STDERR "create file_listoftaxid\n";
if ($otu eq "species") {
	`cat $file_taxid2acc | cut -f2 | sort | uniq > $file_listoftaxid`;
} else {
	`cat $file_lineage | grep $otu | grep -v sub | grep -v super | cut -f3 | sort | uniq > $file_listoftaxid`;
}

#get list of taxid2acc
#here file_listoftaxid contains the list of the taxon, say family, species and etc. 
print STDERR "create file_listoftaxid2acc\n";
`cat $file_listoftaxid | perl $schome/g1_getAccforOTU.pl $file_taxid2acc $file_lineage > $file_listoftaxid2acc`;

#set up al_dir
my $al = $outdir."/acclists";
my $al_dir = $outdir."/acclists/$otu";
mkdir "$al", 0777 unless -d "$al";
mkdir "$al_dir", 0777 unless -d "$al_dir";
#`mkdir $al_dir`;

#set up db_dir
my $db = $outdir."/databases";
my $db_dir = $outdir."/databases/$otu";
mkdir "$db", 0777 unless -d "$db";
mkdir "$db_dir", 0777 unless -d "$db_dir";

#generate list of acc
print STDERR "create acc list file\n";
`cat $file_listoftaxid2acc | perl $schome/g1_makeaccessionlist.pl $al_dir`;

#generate blastdb file
print STDERR "create blastdb file\n";
`cat $file_listoftaxid2acc | perl $schome/g1_makeblastdb.pl $file_1line 1`;
`mv fas* $db_dir`;

`cp $file_1line $outdir`;
`rm $file_listoftaxid2acc $file_listoftaxid $file_taxid2acc`;
